﻿/**
* The FractalBranch is a MovieClip that encapsulates
* the behavior of a branch of the fractal tree.
* 
* @author Robert Penner (AS 1.0)
* © 2002 Robert Penner
* http://www.robertpenner.com
* 
* @author Mark Walters (AS 2.0)
* © 2006 DigitalFlipbook
* http://www.digitalflipbook.com
* 
* @version	1.0
* 
* @since	ActionScript 2.0; Flash Player 6
*/
class com.robertpenner.profmx.fractalTree.FractalBranch extends MovieClip {
	
	/*
	* CLASS PROPERTIES
	*/
	private var fRoot:MovieClip;
	private var numBranches:Number = 0;
	private var myLevel:Number;
	private var myBranch:Number;
	public var setTint:Function;
	
	
	/*
	* *********************************************************
	* CONSTRUCTOR
	* *********************************************************
	*
	*/
	
	function FractalBranch () {
		this.init();
	}
	
	
	/*
	* *********************************************************
	* PRIVATE METHODS
	* *********************************************************
	* 
	*/
	
	private function init ():Void {
		com.robertpenner.display.ColorClip.mixin(this);
		this.numBranches = 0;
		if (this.myLevel == undefined) {
			this.myLevel = 0;
			this.fRoot = this._parent;
		} else {
			this.doColor();
			if (this.myBranch == 1) 
				this.fRoot.xCam.addListener (this);
			else if (this.myBranch == 2)
				this.fRoot.yCam.addListener (this);
		}
	}
	
	private function doColor ():Void {
		if (this.myBranch == 1) 
			var tint:Object = {r:255, g:255, b:255};
		else
			var tint:Object = {r:0, g:0, b:255};
			
		this.setTint (tint.r, tint.g, tint.b, 30);
	}
	
	private function newBranch (branchNum:Number):Void {
		if (this.myLevel >= this.fRoot.maxLevels) return;
		var p = this.fRoot.posers[branchNum];
		var initObj = {
			_x: p._x,
			_y: p._y,
			_xscale: p._xscale,
			_yscale: p._yscale,
			_rotation: p._rotation,
			myLevel: this.myLevel + 1,
			myBranch: branchNum,
			fRoot: this.fRoot
		}
		this.attachMovie ("fractalBranch",
						  "b" + branchNum,
						  branchNum,
						  initObj);
		this.numBranches++;
	}
	
	private function nextBranch ():Void {
		if (this.numBranches < this.fRoot.maxBranches && this.myLevel < this.fRoot.maxLevels) {
			this.newBranch (this.numBranches + 1);
		} else {
			this._parent.nextBranch();
		}
	}
	

	/*
	* *********************************************************
	* EVENT HANDLERS
	* *********************************************************
	* 
	*/
	
	private function onMotionChanged (source:Object, position:Number):Void {
		if (position != undefined) this._rotation = position + 175;
	}
	
}
